//TrouverBlocs_404f.js
// 10.08.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Sert  trouver des blocs auquels une nuance spcifique est applique

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester la version du programme
var appVers = app.version[0];
if (appVers != 6) {
	if (appVers == 4) {
		alert ("Avec InDesign CS2\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else if (appVers == 5) {
		alert ("Avec InDesign CS3\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else {
		alert ("Il ne faut utiliser ce script qu'avec InDesign CS4.", "Attention");
	}
	exit();
}

// tester, s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

curDoc = app.documents[0];
zoomFactor = app.activeWindow.zoomPercentage;

// dresser la liste des couleurs dfinies par l'utilisateur
var allSwatches = curDoc.swatches;
var colorList = new Array();
for (var i=0; i<allSwatches.length; i++) {
	var curSwatch = allSwatches.item(i);
	var cName = curSwatch.name;
	if (cName != "None" && cName != "Black" && cName != "Paper" && cName != "Registration") {
		colorList.push(cName);
	}
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// demander le nom de la nuance  rechercher
var aDialog = app.dialogs.add({name:"Nuances disponibles", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Slectionner la nuance  rechercher"});
				var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
			}
		}
	}
}

// montrer le dialogue
if (aDialog.show() == true) {
	var selColor, aOffset, aTint;
	// reprendre le choix de l'utilisateur
	// le nom de la couleur est l'lment 'selectedIndex' de l'array 'colorList'
	selColor = colorList[colorNames.selectedIndex];
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// les blocs
var allFrames = curDoc.allPageItems;
var nFrames = allFrames.length;
var curFrame, curProps, curTransProps;
var tmpCtr, frameType, imgOkay, aShadow;
var txtCtr = insCtr = unaCtr = imgCtr = linCtr = uknCtr = grpCtr = txtShw = 0;
var curInsPoint, insPointFill, insPointStrk;
for (var i=0; i<nFrames; i++) {
	tmpCtr = 0;
	insPointFill = insPointStrk = "";
	curFrame = allFrames[i];
	curProps = curFrame.properties;
	imgOkay = false;
	aShadow = false;
	if (curFrame == "[object TextFrame]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		curTransProps = curFrame.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			aShadow = true;
		}
		else {
			curTransProps = curFrame.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				aShadow = true;
			}
			else {
				curTransProps = curFrame.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					aShadow = true;
				}
				else {
					curTransProps = curFrame.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						aShadow = true;
					}
				}
			}
		}
		if (tmpCtr > 0) {
			txtCtr++;
			selectIt(curFrame, curProps, "Bloc texte");
		}
		if (tmpCtr == 0) {
			curStory = curFrame.parentStory;
			tsr = curStory.textStyleRanges;
			nTsr = tsr.length;
			if (nTsr == 0) {
				curInsPoint = curStory.insertionPoints[0];
				if (curInsPoint.fillColor != undefined) {
					insPointFill = curInsPoint.fillColor.name;
				}
				if (curInsPoint.strokeColor != undefined) {
					insPointStrk = curInsPoint.strokeColor.name;
				}
				if (insPointFill == selColor || insPointStrk == selColor) {
					curProps = new Array (insPointFill, insPointStrk);
					insCtr++;
					selectIt(curFrame, curProps, "Point d'insertion");
				}
			}
		}
	}
	else if (curFrame == "[object Rectangle]" || curFrame == "[object Oval]" || curFrame == "[object Polygon]") {
		if (curProps.contentType == 1970168179) {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
				}
			}
			curTransProps = curFrame.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				aShadow = true;
			}
			else {
				curTransProps = curFrame.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					aShadow = true;
				}
				else {
					curTransProps = curFrame.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						aShadow = true;
					}
					else {
						curTransProps = curFrame.contentTransparencySettings;
						if (testShadow(curTransProps, selColor)) {
							tmpCtr++;
							aShadow = true;
						}
					}
				}
			}
			if (tmpCtr > 0) {
				unaCtr++;
				selectIt(curFrame, curProps, "Bloc sans contenu");
			}
		}
		else {
			frameType = "Bloc image";
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
				}
			}
			curTransProps = curFrame.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				aShadow = true;
			}
			else {
				curTransProps = curFrame.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					aShadow = true;
				}
				else {
					curTransProps = curFrame.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						aShadow = true;
					}
					else {
						curTransProps = curFrame.contentTransparencySettings;
						if (testShadow(curTransProps, selColor)) {
							tmpCtr++;
							aShadow = true;
						}
					}
				}
			}
			if (tmpCtr == 0) { frameType = "Image" }
			try {
				if (curFrame.graphics[0].properties.fillColor != undefined) {
					if (curFrame.graphics[0].properties.fillColor.name == selColor) {
						imgOkay = true;
						tmpCtr++;
					}
				}
			}
			catch (e) {
			}
			if (tmpCtr > 0) {
				imgCtr++;
				selectIt(curFrame, curProps, frameType, imgOkay);
			}
		}
	}
	else if (curFrame == "[object GraphicLine]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		curTransProps = curFrame.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			aShadow = true;
		}
		else {
			curTransProps = curFrame.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				aShadow = true;
			}
			else {
				curTransProps = curFrame.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					aShadow = true;
				}
				else {
					curTransProps = curFrame.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						aShadow = true;
					}
				}
			}
		}
		if (tmpCtr > 0) {
			linCtr++;
			selectIt(curFrame, curProps, "Bloc trait");
		}
	}
	else if (curFrame == "[object Group]") {
		// les lments d'un groupe sont prsents une seconde fois
		// donc, on ne teste que les effets groupe
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			grpCtr++;
			selectIt(curFrame, curProps, "Groupe");
		}
	}
	else {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
			}
		}
		if (curProps.shadowColor != undefined) {
			if (curProps.shadowColor.name == selColor) {
				tmpCtr++;
				aShadow = true;
			}
		}
		if (tmpCtr > 0) {
			uknCtr++;
			selectIt(curFrame, curProps, "Bloc inconnu");
		}
	}
}

// les tableaux
tabCtr = oldCtr = 0;
var allStories = curDoc.stories;
var nStories = allStories.length;
var nTables, curTable;
var allCells, allColors, curTest, nCells;
for (var i=0; i<nStories; i++) {
	nTables = allStories[i].tables.length;
	for (var k=0; k<nTables; k++) {
		curTable = allStories[i].tables[k];
		for (var m=0; m<1; m++) {
			if (curTable.topBorderStrokeColor != undefined) {
				if (curTable.topBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeColor != undefined) {
				if (curTable.leftBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeColor != undefined) {
				if (curTable.bottomBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeColor != undefined) {
				if (curTable.rightBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.topBorderStrokeGapColor != undefined) {
				if (curTable.topBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeGapColor != undefined) {
				if (curTable.leftBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeGapColor != undefined) {
				if (curTable.bottomBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeGapColor != undefined) {
				if (curTable.rightBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			
			allCells = curTable.cells.everyItem();
			allColors = allCells.fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
		}
	}
	if (oldCtr < tabCtr) {
		oldCtr = tabCtr;
		selectIt(curTable, "", "Tableau");
	}
}

// la fonction qui examine les couleurs
function testItems(allColors) {
	nCol = allColors.length;
	for (c=0; c<nCol; c++) {
		try {
			if (allColors[c].name == selColor) {
				return true;
			}
		}
		catch (e) {
		}
	}
	return false;
}

// informer l'utilisateur
var totCtr = txtCtr + insCtr + imgCtr + unaCtr + linCtr + uknCtr + tabCtr + grpCtr;
if (totCtr == 0) {
	alert ("La nuance recherche  \"" + selColor + "\"\n\nest introuvable.", "Termin");
}

// selectIt-function (thanks to Dave Saunders)
// http://jsid.blogspot.com/2006/01/better-view-after-find.html
function selectIt(curFrame, curProps, frameType, imgOkay) {
	app.select(curFrame, SelectionOptions.replaceWith);
	app.activeWindow.zoomPercentage = zoomFactor;
	showInfos(curFrame, curProps, frameType, imgOkay);
}

function showInfos(curFrame, curProps, frameType, imgOkay) {
	if (frameType != "Tableau" && frameType != "Groupe" && frameType != "Point d'insertion") {
		if (curProps.fillColor != undefined) {
			var curFill = curProps.fillColor.name;
			if (curFill == "None") { curFill = "[Sans]"; }
			else if (curFill == "Paper") { curFill = "[Papier]"; }
			else if (curFill == "Black") { curFill = "[Noir]"; }
			else if (curFill == "Registration") { curFill = "[Reprage]"; }
		}
		else {
			curFill = "non dfini";
		}
		if (curProps.strokeColor != undefined) {
			var curStrk = curProps.strokeColor.name;
			if (curStrk == "None") { curStrk = "[Sans]"; }
			else if (curStrk == "Paper") { curStrk = "[Papier]"; }
			else if (curStrk == "Black") { curStrk = "[Noir]"; }
			else if (curStrk == "Registration") { curStrk = "[Reprage]"; }
		}
		else {
			curFill = "non dfini";
		}
		if (curProps.gapColor != undefined) {
			var curGap = curProps.gapColor.name;
			if (curGap == "None") { curGap = "[Sans]"; }
			else if (curGap == "Paper") { curGap = "[Papier]"; }
			else if (curGap == "Black") { curGap = "[Noir]"; }
			else if (curGap == "Registration") { curGap = "[Reprage]"; }
		}
		else {
			curFill = "non dfini";
		}
	}
	var labelWidth = 80;
	var aDialog = app.dialogs.add({name:frameType});
	with (aDialog.dialogColumns.add()) {
		if (frameType != "Tableau" && frameType != "Groupe" && frameType != "Point d'insertion") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Fond:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curFill});
			}
			with (dialogRows.add()){
				staticTexts.add({staticLabel:"Contour:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curStrk});
			}
			if (curGap == selColor) {
				with (dialogRows.add()){
					staticTexts.add({staticLabel:"Espace:", minWidth:labelWidth});
					staticTexts.add({staticLabel:curGap});
				}
			}
			if (aShadow) {
				with (dialogRows.add()){
					staticTexts.add({staticLabel:"Ombre:", minWidth:labelWidth});
					staticTexts.add({staticLabel:selColor});
				}
			}
			if (imgOkay) {
				with (dialogRows.add()){
					staticTexts.add({staticLabel:"Image:", minWidth:labelWidth});
					staticTexts.add({staticLabel:selColor});
				}
			}
		}
		else if (frameType == "Tableau") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"La nuance...", minWidth:labelWidth});
				staticTexts.add({staticLabel:selColor});
			}
			with (dialogRows.add()){
				staticTexts.add({staticLabel:"... est", minWidth:labelWidth});
				staticTexts.add({staticLabel:"applique"});
			}
		}
		else if (frameType == "Gruppe") {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"La nuance...", minWidth:labelWidth});
				staticTexts.add({staticLabel:selColor});
			}
			with (dialogRows.add()){
				staticTexts.add({staticLabel:"... est utilise", minWidth:labelWidth});
				staticTexts.add({staticLabel:"comme ombre"});
			}
		}
		else if (frameType == "Point d'insertion") {
			var curFill = curProps[0];
			if (curFill == "None") { curStrk = "[Sans]"; }
			else if (curFill == "Paper") { curFill = "[Papier]"; }
			else if (curFill == "Black") { curFill = "[Noir]"; }
			else if (curFill == "Registration") { curFill = "[Reprage]"; }
			var curStrk = curProps[1];
			if (curStrk == "None") { curStrk = "[Sans]"; }
			else if (curStrk == "Paper") { curStrk = "[Papier]"; }
			else if (curStrk == "Black") { curStrk = "[Noir]"; }
			else if (curStrk == "Registration") { curStrk = "[Reprage]"; }
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Fond:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curFill});
			}
			with (dialogRows.add()){
				staticTexts.add({staticLabel:"Contour:", minWidth:labelWidth});
				staticTexts.add({staticLabel:curStrk});
			}
		}
	}
	if (aDialog.show()) {
		aDialog.destroy();
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// la fonction examinant les ombres
function testShadow(curTransProps, selColor) {
	try {
		if (curTransProps.dropShadowSettings.effectColor != undefined) {
			if (curTransProps.dropShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerShadowSettings.effectColor != undefined) {
			if (curTransProps.innerShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.outerGlowSettings.effectColor != undefined) {
			if (curTransProps.outerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerGlowSettings.effectColor != undefined) {
			if (curTransProps.innerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.shadowColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.shadowColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.highlightColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.highlightColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.satinSettings.effectColor != undefined) {
			if (curTransProps.satinSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	return false;
}